<?php
/*******************************************************************************/
//                          InstantCMS v1.8                                    //
//                      http://www.instantcms.ru/                              //
//                         component "Poster"                                  //
//                       written by Marat Fatikhov                             //
//                      (nickname  on a site)                             //
//                       E-mail: f-marat@mail.ru                               //
//                                                                             //
//                      LICENSED BY GNU/GPL v2                                 //
//                                                                             //
/********************************************************************************/

if(!defined('VALID_CMS')) { die('ACCESS DENIED'); }

function checkEditorsAccess($cat_id, $type = ''){
    $inCore = cmsCore::getInstance();
    $inDB = cmsDatabase::getInstance();
    $inUser = cmsUser::getInstance();
    
    //     
    if(($inUser->id) == 1 ){ return true;}

    if($type == 'event'){
        $table = '`cms_poster_eventcats`';
    }else{$table = '`cms_poster_objcats`';}

    $editors = $inDB->get_field("{$table}", "`id` = {$cat_id}", '`editors`');
    //  ,    
    if(!$editors){ return false;}
    
    $editors = $inCore->yamlToArray($editors);
    //  -   ,  
    if (!is_array($editors)) { return false; }
    // id   
		$group_id = $inUser->group_id;
		
		return in_array($group_id, $editors);
}


function uploadImage($cat_id, $item_id, $formname, $type= 'one', $is_objekt=true){
   $inCore = cmsCore::getInstance();

   //  
   if(!isset($_FILES["{$formname}"]["tmp_name"])){return false;}

   //  
   if(!file_exists(PATH."/images/poster")){ mkdir(PATH."/images/poster");}
   if(!file_exists(PATH."/images/poster/small")){ mkdir(PATH."/images/poster/small");}
   if(!file_exists(PATH."/images/poster/medium")){ mkdir(PATH."/images/poster/medium");}

   if($is_objekt){$cat = 'obj_';}else{$cat = '';}

   //     
   if(!file_exists(PATH."/images/poster/small/{$cat}{$item_id}")){ mkdir(PATH."/images/poster/small/{$cat}{$item_id}");}
   if(!file_exists(PATH."/images/poster/medium/{$cat}{$item_id}")){ mkdir(PATH."/images/poster/medium/{$cat}{$item_id}");}
   
   
   $cfg = $inCore->loadComponentConfig('poster');
   $inCore->includeGraphics();
   //  
   if($type == 'one'){
     if (!isset($_FILES["{$formname}"]["name"]) || $_FILES["{$formname}"]["name"] == ''){return false;}

     $file = array();
     // 
     $path_parts             = pathinfo($_FILES["{$formname}"]["name"]);
     $ext                    = strtolower($path_parts['extension']);
     if ($ext != 'jpg' && $ext != 'jpeg' && $ext != 'gif' && $ext != 'png' && $ext != 'bmp') {
       $file['error'] = $_LANG['INADMISSIBLE_EXTENSION_OF_A_FILE'];

     }else{
     
        $file['filename'] = md5(rand().$_FILES["{$formname}"]["name"]).'.jpg';
        $tmp_name   = $_FILES["{$formname}"]["tmp_name"];
        if (@move_uploaded_file($tmp_name, PATH."/images/poster/{$file['filename']}")){

            @img_resize(PATH."/images/poster/{$file['filename']}", PATH."/images/poster/small/{$cat}{$item_id}/{$file['filename']}", $cfg['img_small_w'], $cfg['img_small_w'], $cfg['img_sqr']);
            @img_resize(PATH."/images/poster/{$file['filename']}", PATH."/images/poster/medium/{$cat}{$item_id}/{$file['filename']}", $cfg['img_big_w'], $cfg['img_big_w'], $cfg['img_sqr']);

            @unlink(PATH."/images/poster/{$file['filename']}");
            @chmod(PATH."/images/poster/small/{$cat}{$item_id}/{$file['filename']}", 0755);
            @chmod(PATH."/images/poster/medium/{$cat}{$item_id}/{$file['filename']}", 0755);

            $file['name'] =  $_FILES["{$formname}"]["name"];
        }
    }

    if(isset($_FILES["{$formname}"]["error"])){
      $file['error'] = $_FILES["{$formname}"]["error"];
    }


  }
  //
  if($type == 'multi'){

     if (!isset($_FILES["{$formname}"]["name"][0]) || $_FILES["{$formname}"]["name"][0] ==''){return false;}
     $one_file =array();
     $files = array();
     $count = sizeof($_FILES["{$formname}"]["name"]);
     
     for( $i=0; $i<= $count; $i++){
       // 
       $path_parts             = pathinfo($_FILES["{$formname}"]["name"][$i]);
       $ext                    = strtolower($path_parts['extension']);
       if ($ext != 'jpg' && $ext != 'jpeg' && $ext != 'gif' && $ext != 'png' && $ext != 'bmp') {
          $one_file['error'] = $_LANG['INADMISSIBLE_EXTENSION_OF_A_FILE'];

       }else{

          $one_file['filename'] = md5(rand().$_FILES["{$formname}"]["name"][$i]).'.jpg';
          $tmp_name   = $_FILES["{$formname}"]["tmp_name"][$i];
          if (@move_uploaded_file($tmp_name, PATH."/images/poster/{$one_file['filename']}")){

              @img_resize(PATH."/images/poster/{$one_file['filename']}", PATH."/images/poster/small/{$cat}{$item_id}/{$one_file['filename']}", $cfg['img_small_w'], $cfg['img_small_w'], $cfg['img_sqr']);
              @img_resize(PATH."/images/poster/{$one_file['filename']}", PATH."/images/poster/medium/{$cat}{$item_id}/{$one_file['filename']}", $cfg['img_big_w'], $cfg['img_big_w'], $cfg['img_sqr']);

              @unlink(PATH."/images/poster/{$one_file['filename']}");
              @chmod(PATH."/images/poster/small/{$cat}{$item_id}/{$one_file['filename']}", 0755);
              @chmod(PATH."/images/poster/medium/{$cat}{$item_id}/{$one_file['filename']}", 0755);

              $one_file['name'] =  $_FILES["{$formname}"]["name"][$i];
          }
      }

      if(isset($_FILES["{$formname}"]["error"][$i])){
         $one_file['error'] = $_FILES["{$formname}"]["error"][$i];
      }

      $files[] = $one_file;

    }
  }

  if($file || $files){
     return $file ? $file : $files;

  }else{
    return false;
  }
}

function getImages($item_id, $type='objekt'){

  if($type == 'objekt'){$cat = 'obj_'; }else{ $cat = ''; }

  if(!file_exists(PATH."/images/poster/small/{$cat}{$item_id}")){return false;}

  $files = array();
  $d = @opendir(PATH."/images/poster/small/{$cat}{$item_id}");
  if(!$d){return false;}
  while(($filename=readdir($d)) !== false){
      if($filename == '.' || $filename == '..'){continue;}
      if(preg_match('/\.jpg$/is', $filename) == 0){continue;}
      $files[] =  $filename;
  }
  closedir($d);
  
  return $files ? $files : false;
}

function removeDirectory($dir) {
    if ($objs = glob($dir."/*")) {
       foreach($objs as $obj) {
         is_dir($obj) ? removeDirectory($obj) : unlink($obj);
       }
    }
    rmdir($dir);
  }

//$start_date format 'd-m-Y', $separator '-'
//$end_date format 'd-m-Y', $separator '-'
//return array $days, $day format 'd-m-Y'
function makeCal($start_date, $end_date, $separator='-'){
  $start_date_list = explode($separator, $start_date);
  $end_date_list = explode($separator, $end_date);
  
  if(!checkdate($start_date_list[1], $start_date_list[0], $start_date_list[2])){return false;}
  if(!checkdate($end_date_list[1], $end_date_list[0], $end_date_list[2])){return false;}
  
  $start_date_jd = GregorianToJD($start_date_list[1], $start_date_list[0], $start_date_list[2]);
  $end_date_jd = GregorianToJD($end_date_list[1], $end_date_list[0], $end_date_list[2]);

  $days=array();
  for($i=$start_date_jd; $i<=$end_date_jd; $i++){
      $day = JDToGregorian($i);
      $day_list=explode('/', $day);
      // 0    ,   10
      if($day_list[0]<10){ $day_list[0] = '0'.$day_list[0]; }
      if($day_list[1]<10){ $day_list[1] = '0'.$day_list[1]; }
      $day_str = "{$day_list[1]}-{$day_list[0]}-{$day_list[2]}";
      $days[] = $day_str;
  }

  return  $days;
}

function getLateralMenu($cat_seolink, $orient="", $type="event", $date='', $start_date='', $end_date=''){
     $cat_list = array();
    //    , 
		if ($_SESSION['poster']['cat_list']) {
        $cat_list = $_SESSION['poster']['cat_list'];
    }else{
				//        
        $inCore = cmsCore::getInstance();
        $inCore->loadModel('poster');
        $model = new cms_model_poster();
        $cat_list['event_cats'] = $model->getCategoriesList('event');
        $cat_list['obj_cats'] = $model->getCategoriesList('objekt');
        if($cat_list){
           $_SESSION['poster']['cat_list'] = $cat_list;
        }else{ return false; }
    }

    if(!$date && !$start_date && !$end_date){
      $date = date('d-m-Y');
    }
    if($start_date && $end_date){
       $date = "{$start_date}_{$end_date}";
    }
    
    $current_date = date('d-m-Y');

    switch($orient){
        case 'archive' :
             $href = '/poster/afisha/archive/'.$date.'/'; break;
        case 'today' :
             $href = '/poster/afisha/'.$date.'/'; break;
        case 'soon' :
             $href = '/poster/afisha/soon/'.$date.'/';  break;
       default :
             $href = '/poster/afisha/'.$date.'/'; break;

    }
    
    if($type == 'event'){
         $sel_cat_seolink = $cat_seolink;
    }else{
       $inCore = cmsCore::getInstance();
       $inCore->loadModel('poster');
       $model = new cms_model_poster();
       $cfg = $inCore->loadComponentConfig('poster');
       $main_cat = array();
       $main_cat = $model->getCategory($cfg['main_cat'], 'event');
       $sel_cat_seolink = $main_cat['seolink'];
    }
    $menu =array();
    $menu['orient'] = $orient;
    $menu['current_date'] = $current_date;
    $menu['sel_cat_seolink'] = $sel_cat_seolink;
    $menu['href'] = $href;
    $menu['cat_list'] = $cat_list;
    $menu['cat_seolink'] = $cat_seolink;
    
    return $menu;
}

function getRateOptions(){
     $rate_options = array(
		        1 => ' ',
		        2 => '',
		        3 => '',
		        4 => '',
		        5 => '',
          );

     return  $rate_options;
}

function getCalendar($date='', $start_date=''){

    $inCore = cmsCore::getInstance();
    // 
    if(!$date && !$start_date){ $date = date('d-m-Y'); }
    if($start_date){ $date = date('d-m-Y', strtotime($start_date)); }
    $date_timestap = strtotime($date);
    $date_arr = array();
    $date_arr = explode('-', $date);

    if($inCore->isCached('poster', $date_arr[2].$date_arr[1], 5, 'HOUR')){
        $calendar_y = $inCore->getCache('poster', $date_arr[2].$date_arr[1]);
        $calendar = array();
        $calendar = $inCore->yamlToArray($calendar_y);
        return $calendar;
    }else{
        if(checkdate($date_arr[1], $date_arr[0], $date_arr[2]) != 1){ return false; }

        $calendar = array();
        setlocale(LC_ALL, 'ru');
        //
        $calendar['yahr'] = $date_arr[2];
        // 
        $calendar['month']['title'] = $inCore->getRusDate(date('F',strtotime($date)));
        $calendar['month']['num']   =  $date_arr[1];
        // 
        $calendar['week_days'] = array(0=>'',
                                       1=>'',
                                       2=>'',
                                       3=>'',
                                       4=>'',
                                       5=>'',
                                       6=>'');
        // 
        $calendar['days'] = array();

        //      
        $dayofmonth = date('t', $date_timestap);
        //    
        $day_count = 1;

        // 1.  
        $num = 0;
        for($i = 0; $i < 7; $i++){
          //      
          $dayofweek = date('w', mktime(0, 0, 0, date('m',$date_timestap), $day_count, date('Y',$date_timestap)));
          //      1 - , ..., 6 - 
          $dayofweek = $dayofweek - 1;
          if($dayofweek == -1) $dayofweek = 6;

          if($dayofweek == $i){
            //    ,
            //   $week
            //  
            $week[$num][$i]['num'] = $day_count;
            $week[$num][$i]['date'] = strtotime("{$day_count}-{$date_arr[1]}-{$date_arr[2]}");
            $day_count++;
          }else{
             $week[$num][$i] = "";
          }
        }

        // 2.   
        while(true){
          $num++;
          for($i = 0; $i < 7; $i++){
            $week[$num][$i]['num'] = $day_count;
            $week[$num][$i]['date'] = strtotime("{$day_count}-{$date_arr[1]}-{$date_arr[2]}");
            $day_count++;
            //     - 
            //  
             if($day_count > $dayofmonth) break;
          }
          //     - 
          //  
          if($day_count > $dayofmonth) break;
        }
        $calendar['days'] = $week;
        //     
        $next_month = $date_arr[1]+1;
        $next_yahr = $date_arr[2];
        if($next_month >12){ $next_yahr += 1; $next_month = 1;}
        $last_month = $date_arr[1]-1;
        $last_yahr = $date_arr[2];
        if($last_month <1){ $last_yahr -= 1; $last_month = 12;}
        for($i=28; $i<=31; $i++){
            if(checkdate($last_month, $i, $last_yahr) == 1) $last_month_end = $i;
            if(checkdate($next_month, $i, $next_yahr) == 1) $next_month_end = $i;
        }
        $calendar['last_month_date'] = "1-{$last_month}-{$last_yahr}_{$last_month_end}-{$last_month}-{$last_yahr}";
        $calendar['next_month_date'] = "1-{$next_month}-{$next_yahr}_{$next_month_end}-{$next_month}-{$next_yahr}";

        //    
        $inCore = cmsCore::getInstance();
        $inCore->loadModel('poster');
        $model = new cms_model_poster();
        $binds = array();
        $binds = $model->getBindsAll("1-{$date_arr[1]}-{$date_arr[2]}", "{$dayofmonth}-{$date_arr[1]}-{$date_arr[2]}");

          if($binds){
             foreach($binds as &$bind){
               $bind['time_list'] = $inCore->YamlToArray($bind['time_list']);
             }
          }
          foreach($calendar['days'] as $key=>&$row){
            foreach($row as $x=>&$day){
                $day['binds_count'] = 0;
                if($binds){
                  foreach($binds as $bnd){
                       $start_tmstmp = strtotime($bnd['start_date']);
                       $end_tmstmp = strtotime($bnd['end_date']);
                       if($bnd['all_days']){
                          if($day['date'] >= $start_tmstmp && $day['date'] <= $end_tmstmp){
                            $day['binds_count'] = ++$day['binds_count'];
                          }
                       }else{
                           foreach($bnd['time_list'] as $t=>$d){
                             if(strtotime($t) == $day['date']){
                               $day['binds_count'] = ++$day['binds_count'];
                             }
                          }
                       }
                  }
                }
            }

          }
        // 
        $calendar_y = $inCore->arrayToYaml($calendar);
        $inCore->saveCache('poster', $date_arr[2].$date_arr[1], "$calendar_y");
        return $calendar;
    }
}

//   
function getRusDate($datestr){
        $datestr = str_replace('January', '', $datestr);
        $datestr = str_replace('February', '', $datestr);
        $datestr = str_replace('March', '', $datestr);
        $datestr = str_replace('April', '', $datestr);
        $datestr = str_replace('May', '', $datestr);
        $datestr = str_replace('June', '', $datestr);
        $datestr = str_replace('July', '', $datestr);
        $datestr = str_replace('August', '', $datestr);
        $datestr = str_replace('September', '', $datestr);
        $datestr = str_replace('October', '', $datestr);
        $datestr = str_replace('November', '', $datestr);
        $datestr = str_replace('December', '', $datestr);
        
        //  
        $datestr = str_replace('Mon', '', $datestr);
        $datestr = str_replace('Tue', '', $datestr);
        $datestr = str_replace('Wed', '', $datestr);
        $datestr = str_replace('Thu', '', $datestr);
        $datestr = str_replace('Fri', '', $datestr);
        $datestr = str_replace('Sat', '', $datestr);
        $datestr = str_replace('Sun', '', $datestr);

        //   01 02  1 2
        $day_int = array(
					'01', '02', '03',
					'04', '05', '06',
					'07', '08', '09'
				 );
				 $day_norm = array(
					'1', '2', '3',
					'4', '5', '6',
					'7', '8', '9'
				 );

				$datestr = str_replace($day_int, $day_norm, $datestr);

        return $datestr;
    }
    
    function getCities(){
          $inCore = cmsCore::getInstance();
          $inDB = cmsDatabase::getInstance();

          $sql = "SELECT DISTINCT addr_city as city
                  FROM `cms_poster_objekts`";

          $result = $inDB->query($sql);
          if(!$inDB->num_rows($result)){ return false; }
          $cityes = array();
          while($item = $inDB->fetch_assoc($result)){
              $cityes[] = $item['city'];
          }
          return $cityes;
    }

?>
