<?php
/*******************************************************************************/
//                          InstantCMS v1.8                                    //
//                      http://www.instantcms.ru/                              //
//                component "Poster", module "Calendar"                        //
//                       written by Marat Fatikhov                             //
//                      (nickname  on a site)                             //
//                       E-mail: f-marat@mail.ru                               //
//                                                                             //
//                      LICENSED BY GNU/GPL v2                                 //
//                                                                             //
/********************************************************************************/

header('Content-Type: text/html; charset=windows-1251');
header('Cache-Control: no-cache');

session_start();

define("VALID_CMS", 1);
define('PATH', $_SERVER['DOCUMENT_ROOT']);

include(PATH.'/core/cms.php');

$inCore = cmsCore::getInstance();

$inCore->loadClass('db');
$inCore->loadClass('user');
$inCore->loadClass('page');

cmsCore::loadLanguage('lang');
cmsCore::loadLanguage('components/poster');
$com_cfg = $inCore->loadComponentConfig('poster');
$inCore->includeFile('components/poster/includes/postercore.php');

$inDB   = cmsDatabase::getInstance();
$inUser = cmsUser::getInstance();

$inUser->update();

//  
$tmstmp = $inCore->request('tmstmp', 'int' , time());

$date = date('Y-m-d', $tmstmp);

// ,   
$access_lists = array();
$access_lists = $inDB->get_table("`cms_poster_eventcats`", '', 'id, access_list');

if(!$access_lists){ return false; }
$cats = array();
foreach($access_lists as $key=>$value){
      if($inCore->checkContentAccess($value['access_list'])){
          $cats[] = $value['id'];
      }
}
if(!$cats){ return false; }
$cats_str = implode(',', $cats);
$where ="(b.start_date <= DATE_FORMAT('{$date}','%Y-%m-%d') AND b.end_date >= DATE_FORMAT('{$date}','%Y-%m-%d'))";
$where .= " AND e.cat_id IN ({$cats_str})";

$orderby = 'e.'.$com_cfg['main_orderby'];
$orderto = $com_cfg['main_orderto'];

$sql = "SELECT e.id, e.author_id, e.title, e.seolink, e.shortdesc, e.basic_photo, e.rating, e.rating_votes, ec.seolink as event_cat_seolink, ec.cat_config,
                         b.id as bind_id, b.all_days, b.time_list, b.objekt_id, DATE_FORMAT(b.start_date, '%d-%m-%Y') as start_date,
                         DATE_FORMAT(b.end_date, '%d-%m-%Y') as end_date, o.title as objekt_title, o.seolink as objekt_seolink,
                         oc.seolink as objekt_cat_seolink
                  FROM `cms_poster_events` e
                  INNER JOIN `cms_poster_bind` b ON b.event_id=e.id
                  LEFT JOIN `cms_poster_eventcats` ec ON ec.id=e.cat_id
                  LEFT JOIN `cms_poster_objekts` o ON o.id=b.objekt_id
                  LEFT JOIN `cms_poster_objcats` oc ON oc.id=o.cat_id
                  WHERE {$where} AND e.published=1 AND o.published=1 AND oc.published=1
                  ORDER BY {$orderby} {$orderto}";
                  
$result = $inDB->query($sql) ;
if(!$inDB->num_rows($result)){return false;}
$mash = array();
while($row = $inDB->fetch_assoc($result)){
    $mash[] = $row;
}
$events = array();
$check = array();
foreach($mash as $key=>$value){
  $half = array();
  if(($unic_key = array_search($value['id'], $check, true)) !== false){
     $half = array_chunk($value, 10, true);
     $events["{$unic_key}"]['binds'][]= $half[1];
  }else{
     $half = array_chunk($value, 10, true);
     $events["{$key}"] = $half[0];
     $events["{$key}"]['binds'][] = $half[1];
     $check[] = $value['id'];
  }
}
//  ,     
foreach($events as $key=>&$event){
      $event['is_bind'] =false;
       foreach($event['binds'] as $b=>$bind){
          if(!$bind['all_days']){
             $time_list = $inCore->YamlToArray($bind['time_list']);
             foreach($time_list as $t=>$day){
                 if($t == date('d-m-Y',strtotime($date))){
                    $event['is_bind'] =true;
                 }
             }
          }else{
              $event['is_bind'] =true;
          }
       }
}
//     
//
    $inCore->loadLib("tags");
foreach($events as $key=>&$event){
   $event['count'] = count($event['binds']) - 1;
   $event['comments_count'] = $inCore->getCommentsCount('event', $event['id']);
   $event['tag_bar'] = cmsTagBar('posterevent', $event['id']);
   $event['cat_config']= $inCore->yamlToArray($event['cat_config']);
}
//
$rate_options = getRateOptions();
//  
    $smarty = $inCore->initSmarty('modules', 'mod_poster_calendarevents.tpl');
    $smarty->assign('events', $events);
    $smarty->assign('LANG', $_LANG);
    $smarty->assign('com_cfg', $com_cfg);
    $smarty->assign('rate_options', $rate_options);
    $smarty->display('mod_poster_calendarevents.tpl');

   return true;

?>
